// mellonConfig and mellonUrl are required

window.mellonBridgeInit = function (urn) {
  'use strict';

  var bridge = new MellonBridge(mellonConfig),
    channel = bridge.getNewChannel(urn);

  channel
    .on('close', function () {
      var modal = $('div.jqFensterModal:visible');
      if (modal.length) {
        $.fensterFinder(modal).close().destroy();
      }
    })

    .on('redirect', function (params) {
      window.location.href = params.url;
    })

    .on('resize', function (w, h) {
    	 var animateOptions = {};
         //Check if the dialog width is bigger of window width
         // resize and reposition the dialog to fit the window.
         var windowWidth = $(window).width();
         if(w > windowWidth){
             w = windowWidth - 10;
             $('td.jqFensterContent').animate({padding:5}, 'fast');
         }
         //keep minimum width on 300
         w = w < 300 ? 300 : w;
         h = h < 200 ? 200 : h;
         $('div.jqFensterModalContent iframe').animate({width: w, height: h + 20}, 'fast');
     
    	
    });

  return channel.createInstance(urn);
};

$(function () {
  var bridge = new MellonBridge(mellonConfig);

  $('#reg-key-submit').on('click', function (e) {
    var $form = $('form.reg-key-form'),
      $err = $form.find('.error-message'),
      regKey = $form.find('input').val(),
      url = bridge.prepareUrnForGame(mellonUrl.getAjaxBetaKeyValidate(regKey));

    if (!regKey) {
      return false;
    }

    $.getJSON(url).success(function (data) {
      if (!data || !data.success) {
          var msg = '';
          for (var i in data.messages) {
            msg += '<p>' + data.messages[i] + '</p>';
          }
          $err.html(msg).fadeIn('fast');
          return false;
      }

      // main page stuff
      current.hide();
      current = $('#tribe-pop-up').show(0, function () {
        $(this).trigger('mellonGwSelection', regKey);
      });
      tribeSelection = true;
    });

    return false;
  });

  $('#tribe-pop-up').on('mellonGwSelection', function (e, regKey) {
    var url = bridge.prepareUrnForGame(mellonUrl.getAjaxGameWorldList('registration')),
      $btnPlayNow = $('#btnPlayNow').addClass('disabled')
      .on('click', function () {
        return false;
      });

    $.getJSON(url).success(function (data) {
      if (!data || !data.success || !$.isArray(data.list)) {
          return false;
      }

      $btnPlayNow.text($btnPlayNow.data('template').replace('%s', data.list[0].title))
        .removeClass('disabled')
        .on('click', function () {
          mellonConfig.application.countryId = data.list[0].applicationCountryId;
          mellonConfig.application.instanceId = data.list[0].applicationInstanceId;

          var userParam = 'teuton',
            $char = $('#char-foreground .char');

          switch (true) {
            case ($char.hasClass('gaul')):
              userParam = 'gaul';
              break;
            case ($char.hasClass('roman')):
              userParam = 'roman';
              break;
          }

          var $link = $('<a>').addClass('jqFenster')
            .data({
              mellonIframeUrl: mellonUrl.getInstantLogin(userParam, regKey),
              selector: '#mellonModal'
            });

          $('body').append($link);
          $link.trigger('click');
        });
    });
  });
});